<script type="text/ecmascript-6">
    import InvoiceCancelForm from "./InvoiceCancelForm";
    import {printDivById}    from "./../../helpers/helper";
    import axios             from "axios";

    export default {
        name: "Invoice",

        components: {
            "invoice-cancel-form": InvoiceCancelForm,
        },

        props: {
            printStatusApi: {required: true, type: String},
            isBillPrinted: {required: true, type: Boolean},
        },

        data() {
            return {
                showCancelForm: false,
                copy_of_original: false,
            };
        },

        watch: {
            isBillPrinted: {
                handler: function() {
                    this.copy_of_original = this.isBillPrinted;
                },
                immediate: true,
            },
        },

        mounted() {
            const _self = this;
            document.addEventListener("afterPrint", this.handleAfterPrint);

            window.addEventListener("keydown", function(event) {
                if (event.ctrlKey && (event.key === "p" || event.key === "P")) {
                    event.preventDefault();
                    _self.printInvoice();
                }
            });
        },

        methods: {
            hideCancelFormModal() {
                this.showCancelForm = false;
            },

            showCancelFormModal() {
                this.showCancelForm = true;
            },

            printInvoice() {
                printDivById("print-invoice");
            },

            handleAfterPrint() {
                axios.post(this.printStatusApi).then(response => {
                    if (response.data.success) {
                        this.copy_of_original = true;
                    }
                });
            },

            printShortCutHandler(event) {
                console.log(event);
            },
        },
    };
</script>

<style scoped>
    .s18 {
        font-size: 18px !important;
    }
</style>
